/*
 * Copyright (c), Lawrence Foard, 1992
 *
 * Developed under contract by Virtual World Information systems.
 * Questions and suggestions about this package may be directed to:
 * lfoard@turing.org, entropy@world.std.com
 * 
 * Those without e-mail access can call the VWIS Linux support BBS
 * at 1-508-793-9568 and send e-mail to entropy,
 * or send snail mail to:
 *
 * Virtual World Information Systems
 * 217 Park Ave.
 * Box #108
 * Worcester MA 01609
 *
 * This code may be used under the terms of the GNU license.
 * Other licensing agreements may be negotiated with VWIS.
 *
 */
 
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include "head.h"

unsigned short reg_ds,reg_cs,reg_ss,reg_es,reg_fs,reg_gs;
int sig_count=0;
char sig_counts[32];
extern PROCESS *proc;

int ltoz[32];
int ztol[32];

init_cvt()
 {
  int a;
  for(a=0;a<32;a++)
   ltoz[a]=ztol[a]=0;
  ltoz[SIGHUP]=1;
  ltoz[SIGINT]=2;
  ltoz[SIGQUIT]=3;
  ltoz[SIGILL]=4;
  ltoz[SIGTRAP]=5;
  ltoz[SIGABRT]=6;
  ltoz[SIGIOT]=6;
  ltoz[SIGFPE]=8;
  ltoz[SIGKILL]=9;
  ltoz[SIGUSR1]=16;
  ltoz[SIGSEGV]=11;
  ltoz[SIGUSR2]=17;
  ltoz[SIGPIPE]=13;
  ltoz[SIGALRM]=14;
  ltoz[SIGTERM]=15;
  ltoz[SIGCLD]=18;
  for(a=0;a<32;a++)
   ztol[ltoz[a]]=a;
  ztol[0]=0;
 }

void sig_giveup()
 {
  fprintf(stderr,"Signal!!!\n");
  _exit(0);
 }

extern int sig_count;
extern char sig_counts[32];
extern int call_stack_pointer;

struct sig_stack
 {
  struct registers regs;
  unsigned int restorer;
  unsigned int sig_num;
 };

/* structure of stack setup by kernel for signal */
struct kernel_save
 {
  unsigned int ebp;
  unsigned int edi;
  unsigned int esi;
  unsigned int ebx;
  unsigned int restorer; /* restore address passed to kernel */
  unsigned int number; /* signal # */
#ifdef kjdfk
  unsigned int mask; /* signal mask, might be there? */
#endif  
  unsigned int eax;
  unsigned int ecx;
  unsigned int edx;
  unsigned int flags;
  unsigned int eip;
 };

/* execute a signal */
void sig_handler()
 {
  int a;
  struct sig_stack *stk;
  struct registers *oregs;
  sig_count--;
  for(a=0;(a<32) && !sig_counts[a]--;a++)
   sig_counts[a]++;
  if (a==32)
   {
    fprintf(stderr,"!!!signal corruption!!!\n");
    _exit(1);
   }
  if (!(a=ltoz[a])) 
   return;
  /* make room for signal setup */
  oregs=(struct registers *)&proc->prog_area[call_stack_pointer];
  call_stack_pointer-=sizeof(struct sig_stack);
  stk=(struct sig_stack *)&proc->prog_area[call_stack_pointer];
  stk->regs=*oregs;
  stk->restorer=proc->restorer;
  stk->sig_num=a;
  stk->regs.eip=proc->handlers[a];
  stk->regs.cs=0x1f;
  if (proc->debug)
   {
    fprintf(proc->debug,"Got signal %d=%d\n",a,proc->handlers[a]);
    fflush(proc->debug);
   }
 }

get_signal();

int set_sig(int num,int loc)
 {
  if (loc>2)
   proc->handlers[num]=loc;
  if (ztol[num])
   return(signal(ztol[num],get_signal));
  else
   return 0;
 }

void adjust_stack()
 {
  struct kernel_save *sv,tmp;
  struct registers *regs;
  sv=(struct kernel_save *)(call_stack_pointer+proc->prog_area);
  tmp=*sv;
  call_stack_pointer+=sizeof(struct kernel_save);
  regs=(struct registers *)(&proc->prog_area[call_stack_pointer-=sizeof(struct registers)]);
  regs->eax=tmp.eax;
  regs->ebx=tmp.ebx;
  regs->ecx=tmp.ecx;
  regs->edx=tmp.edx;
  regs->edi=tmp.edi;
  regs->esi=tmp.esi;
  regs->ebp=tmp.ebp;
  regs->flags=tmp.flags;
  regs->eip=tmp.eip;
  regs->cs=0x1f;
  sig_count++;
  sig_counts[tmp.number]++;
 }
 